標籤:
Problem Description
都 說天上不會掉餡餅,但有一天gameboy正走在回家的小徑上,忽然天上掉下大把大把的餡餅。說來gameboy的人品實在是太好了,這餡餅別處都不掉, 就掉落在他身旁的10米範圍內。餡餅如果掉在了地上當然就不能吃了,所以gameboy馬上卸下身上的背包去接。但由於小徑兩側都不能站人,所以他只能在 小徑上接。由於gameboy平時老呆在房間裡玩遊戲,雖然在遊戲中是個身手敏捷的高手,但在現實中運動神經特別遲鈍,每秒種只有在移動不超過一米的範圍 內接住墜落的餡餅。現在給這條小徑標上座標:
為了使問題簡化,假設在接下來的一段時間裡,餡餅都掉落在0-10這11個位置。開始時gameboy站在5這個位置,因此在第一秒,他只能接到4,5,6這三個位置中其中一個位置上的餡餅。問gameboy最多可能接到多少個餡餅?(假設他的背包可以容納無窮多個餡餅)
Input
輸 入資料有多組。每組資料的第一行為以正整數n(0<n<100000),表示有n個餡餅掉在這條小徑上。在結下來的n行中,每行有兩個整數 x,T(0<T<100000),表示在第T秒有一個餡餅掉在x點上。同一秒鐘在同一點上可能掉下多個餡餅。n=0時輸入結束。
Output
每一組輸入資料對應一行輸出。輸出一個整數m,表示gameboy最多可能接到m個餡餅。
提示:本題的輸入資料量比較大,建議用scanf讀入,用cin可能會逾時。
Sample Input
65 14 16 17 27 28 30
Sample Output
4
思路:
這道題其實就是數字三角(數塔),使用動態規劃來解題,把時間T看做行數,把位置X看成列數,每次從左、中、右三個方向遞推。為計算方便,每列X數值加1,這樣第0列左邊、第10列右邊都是0,gameboy就不可能跑出界外。
代碼:
#include <iostream>#include <string.h>using namespace std;const int maxt = 100001;int dp[maxt][15];int cookies[maxt][15];int main(){ int n; while (scanf("%d", &n) != EOF && n) { int time = 0; memset(dp, 0, sizeof(dp)); memset(cookies, 0, sizeof(cookies)); while (n--) { int a, b; scanf("%d%d", &a, &b); cookies[b][a + 1]++; if (b > time) { time = b; } } for (int i = 1; i <= 11; i++) { dp[time][i] = cookies[time][i]; } for (int i = time - 1; i >= 0; i--) { for (int j = 1; j <= 11; j++) { int left = dp[i + 1][j - 1] + cookies[i][j]; int mid = dp[i + 1][j] + cookies[i][j]; int right = dp[i + 1][j + 1] + cookies[i][j]; int ans = left > mid ? left : mid; ans = ans > right ? ans : right; dp[i][j] = ans; } } printf("%d\n", dp[0][6]); } system("pause"); return 0;}
hdu 1176 免費餡餅